using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.Domain.Elastics.Inventories.Categories;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Application.Commands.Inventories.Categories
{
    public class SyncUserDistrictHandler : MediatR.IRequestHandler<SyncUserDistrictCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IUserDistrictRepository _UserDistrictRepository;
        private readonly IBus _bus;

        public SyncUserDistrictHandler(IConfiguration configuration, IUserDistrictRepository UserDistrictRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("InventoryConnection");
            _dbConnection = new SqlConnection(connectionString);
            _UserDistrictRepository = UserDistrictRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncUserDistrictCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticUserDistrict", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} UserDistricts" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var entities = await _dbConnection.QueryAsync<UserDistrictElastic>("Sync_UserDistrict_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (entities.Any())
                {
                    var cityIds = entities.Where(x => x.CityId > 0).Select(x => (long)x.CityId).Distinct().ToList();
                    var p3 = new Dto.DapperTypes.IdsParam(cityIds);
                    var cities = await _dbConnection.QueryAsync<CategoryElastic>("Sync_Category_Get_By_List_Id", p3, commandType: CommandType.StoredProcedure);
                    if (cities.Any())
                    {
                        var areaIds = cities.Where(x => x.AreaId > 0).Select(x => (long)x.AreaId).Distinct().ToList();
                        var p4 = new Dto.DapperTypes.IdsParam(areaIds);
                        var areas = await _dbConnection.QueryAsync<CategoryElastic>("Sync_Category_Get_By_List_Id", p4, commandType: CommandType.StoredProcedure);
                        foreach (var item in entities)
                        {
                            var city = cities.FirstOrDefault(x => x.Id == item.CityId);
                            if (city != null)
                            {
                                item.CityName = city.Name;
                                item.AreaId = city.AreaId;
                                var area = areas.FirstOrDefault(x => x.Id == item.AreaId);
                                if (area != null)
                                {
                                    item.AreaName = area.Name;
                                    item.Region = area.Region;
                                }
                            }
                        }
                    }
                    var rs2 = await _UserDistrictRepository.AddManyAsync(entities);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_UserDistrict_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{entities.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}